// QuickpostTemplate.h - Header file for QTM quickpost template objects
//
// Copyright (C) Matthew J Smith, 18th January 2007
// Licensed under GNU General Public License, version 2 or later

#include <QObject>
#include <QAction>
#include <QString>

#include "QuickpostTemplate.h"

QuickpostTemplate::QuickpostTemplate( int id, QString t,
				      QString pt, QObject *parent )
  : QAction( t, parent )
{
  _postTemplate = pt;
  _identifier = id;

  connect( this, SIGNAL( triggered( bool ) ),
	   this, SLOT( emitRequestedSignal() ) );
}

QuickpostTemplate::~QuickpostTemplate()
{
  deleteLater();
}


void QuickpostTemplate::setIdentifier( int i )
{
  _identifier = i;
}

void QuickpostTemplate::setPostTemplate( QString newTemplate )
{
  _postTemplate = newTemplate;
}

void QuickpostTemplate::emitRequestedSignal()
{
  emit quickpostRequested( _identifier, _postTemplate );
}

int QuickpostTemplate::identifier()
{
  return _identifier;
}

QString QuickpostTemplate::postTemplate()
{
  return _postTemplate;
}
