// QuickpostTemplateDialog.h - Quickpost template configuration dialog for QTM
//
// Written by Matthew J Smith, 13th Feb 2007
//
// This is released under the GNU General Public License as is the rest of
// the QTM package
// http://qtm.blogistan.co.uk

#include <QtGlobal>
#if QT_VERSION >= 0x040200

#include "ui_QuickpostTemplateForm.h"

#include <QStringList>
#include <QList>

class QDialog;
class QWidget;
class QAction;

class QuickpostTemplateDialog : public QDialog, public Ui::QuickpostTemplateForm
{
  Q_OBJECT

 public:
  QuickpostTemplateDialog( QStringList &, QStringList &, 
			   QList<int> &, QWidget *parent = 0 );
  QStringList templateTitles() { return _templateTitles; }
  QStringList templateStrings() { return _templateStrings; }
  QList<int> defaultPublishStates() { return _defaultPublishStates; }

private slots:
  void changeListIndex( int );
  void doNewTemplate();
  void on_pbNewTemplate_clicked() { doNewTemplate(); }
  void removeThisTemplate();
  void on_pbAccept_clicked();
  void on_pbWhatsThis_clicked();
  void on_pbReset_clicked();
  void on_buttonBox_accepted();

private:
  QStringList _templateTitles, _templateStrings;
  QStringList originalTitles, originalStrings;
  QList<int> _defaultPublishStates, originalPublishStates;
  // QStringListModel *titlesModel;
  bool doingNewTemplate;
  // QModelIndex currentListIndex;
  int currentRow;
  // int lowestNumber; // lowest number of templates in the list in the session
  QAction *addTemplate; 
  QAction *removeTemplate;
  QString currentTemplateTitle, currentTemplateString;
};

#endif
