// SafeHttp.h - Header for SafeHttp class, a cover for QHttp which checks for the
// existence of a host before posting data to it.
//
// Distributed under the GNU General Public License, version 2.
// Copyright (C) 2006 Matthew J Smith

#include <QtGlobal>
#include <QHttp>

class QString;
class QIODevice;
class QByteArray;
class QHostInfo;

class SafeHttp : public QHttp
{
Q_OBJECT

public:
  SafeHttp( QObject *parent = 0 );
  SafeHttp( const QString &, quint16, QObject *parent = 0 ); 
  ~SafeHttp();
  int currentHttpBusiness();
  void setCurrentHttpBusiness( int );

public slots:
  void safePost( const QString &, const QString &, 
		 const QByteArray &, 
	    	 QIODevice *dataTo = 0 );
  void handleLookupResult( const QHostInfo & );

private:
  QString location;
  QString httpHost;
  QByteArray httpData;
  QIODevice *httpDataTo;
  int _currentHttpBusiness;

signals:
  void hostLookupFailed();
};
