/*******************************************************************************
 
    QTM - Qt-based blog manager
    Copyright (C) 2006 Matthew J Smith

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License (version 2), as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/

// XmlRpcHandler.h - Header for QTM XML-RPC routines

#ifndef XMLRPCHANDLER_H
#define XMLRPCHANDLER_H

#include <QtXml>
#include <QtCore>

class XmlRpcHandler : public QXmlDefaultHandler
{
public:
  XmlRpcHandler( int x );
  XmlRpcHandler();

  void setProtocol( int x );

  bool startElement( const QString &namespaceURI,
		     const QString &localName,
		     const QString &qName,
		     const QXmlAttributes &attr );
  bool endElement( const QString &nu,
		   const QString &localName,
		   const QString &qName );
  bool characters( const QString &str );
  bool fatalError( const QXmlParseException &exc );
  bool isMethodResponseFinished();
  QList<QString> returnList();

private:
  int reqType;
  QString currentString;
  QList<QString> returnData;
  bool methodResponseFinished;
};

#endif
