// locationlineedit.cc - Custom line editor for location of XML-RPC
// request receivers
//
// Written by Matthew J Smith, 3rd July 2006
//
// This is released under the GNU General Public License as is the rest of
// the QTM package
// http://qtm.blogistan.co.uk

#include <QLineEdit>
#include <QWidget>
#include <QMenu>
#include <QContextMenuEvent>

#include "locationlineedit.h"

LocationLineEdit::LocationLineEdit( QWidget *parent )
  : QLineEdit( parent )
{
}

void LocationLineEdit::contextMenuEvent( QContextMenuEvent *event )
{
  QMenu *menu = new QMenu( this );
  menu->addAction( "mt-xmlrpc.cgi (Movable Type)", this,
		   SLOT( addMT() ) );
  menu->addAction( "xmlrpc.php (WordPress)", this,
		   SLOT( addWordpress() ) );
  menu->addAction( "/textpattern/xmlrpcs.php (TextPattern)", this,
		   SLOT( addTextpattern() ) );
  menu->addSeparator();
  QMenu *cm = createStandardContextMenu();
  cm->setTitle( tr( "Editing" ) );
  menu->addMenu( cm );
  menu->exec( event->globalPos() );
}

void LocationLineEdit::addMT()
{
  insert( "mt-xmlrpc.cgi" );
}

void LocationLineEdit::addWordpress()
{
  insert( "xmlrpc.php" );
}

void LocationLineEdit::addTextpattern()
{
  insert( "/textpattern/xmlrpcs.php" );
}
